﻿using igGridTotalRecordsCount.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace igGridTotalRecordsCount.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        [ActionName("GridGetData")]
        public ActionResult GridGetData()
        {
            List<Products> dataTable = DataTableToModel(GetCategoriesProductDataSet().Tables[0]);
            DataModel model = new DataModel() { Records = dataTable, TotalRecordsCount = 20 };
            var m = new { Records = dataTable, TotalRecordsCount = 20 };
            JsonResult result = new JsonResult();
            result.Data = model;
            result.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
            return result;
        }

        public List<Products> DataTableToModel(DataTable table)
        {
            List<Products> parentRow = new List<Products>();
            Products childRow;
            foreach (DataRow row in table.Rows)
            {
                childRow = new Products();
                childRow.ID = Int32.Parse(row.ItemArray[0].ToString());
                childRow.Fruit = row.ItemArray[1].ToString();
                childRow.Quantity = Int32.Parse(row.ItemArray[2].ToString());

                parentRow.Add(childRow);
            }
            return parentRow;
        }


        private DataSet GetCategoriesProductDataSet()
        {
            DataSet ds = new DataSet("CategoriesProducts");

            DataTable dt = new DataTable("Products");
            dt.Columns.Add("ID");
            dt.Columns.Add("Fruit");
            dt.Columns.Add("Quantity");

            dt.Columns["Quantity"].DataType = Type.GetType("System.Int32");

            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = dt.Columns["ID"];
            dt.PrimaryKey = PrimaryKeyColumns;

            for (var i = 0; i < 1; i += 4)
            {
                dt.Rows.Add(new object[] { i, "Bannana", i });
                dt.Rows.Add(new object[] { i + 1, "Apple", i + 1 });
                dt.Rows.Add(new object[] { i + 2, "Orange", i + 2 });
                dt.Rows.Add(new object[] { i + 3, "Apple", i + 3 });

            }
            
            ds.Tables.Add(dt);;
            return ds;
        }

        
    }
}